'use strict';
/*
 * GET home page.
 */
var http = require('http'),
    fs = require('fs'),
    path = require('path'),
    iconv = require('iconv-lite'),
    UglifyJS = require('uglify-js'),
    cleanCSS = new require('clean-css')({
        noAdvanced: true
    }),
    BufferHelper = require('bufferhelper');


//压缩js
var minify = function (code) {
    return UglifyJS.minify(code, {
        fromString: true
    });
};
//压缩css
var minicss = function (source) {
    return cleanCSS.minify(source);
    // return cleanCSS.process(code);
};

//按照url获取文件内容
var getFile = function (url, callback) {
    var resultdata = '';
    // url = url.replace(/\.\.\//g, '').replace(/\.\//g, '').split('|');
    url = url.split('|');
    if (url[0].indexOf('http') === 0) {
        http.get(url[0], function (p_res) {
            var bfHelper = new BufferHelper();
            if (p_res.statusCode != 404) {
                p_res.on('data', function (chunk) {
                    bfHelper.concat(chunk);
                });
                p_res.on('end', function () {
                    resultdata = bfHelper.toBuffer();
                    resultdata = iconv.decode(resultdata, (url[1] || 'UTF8').toUpperCase());
                    resultdata = iconv.encode(resultdata, 'UTF8');
                    callback('/*path --' + url[0] + '*/\r\n' + resultdata, true);
                });
            }
            else {
                callback('/*Read Error --' + url[0] + '*/\r\n', false);
            }
        });
    }
    else {
        var m1 = url[0];
        console.log(m1);
        var parent = path.resolve(process.cwd() + '/hui_modules/');
        var root = path.resolve(new Array(parent.replace(/\\+/g, '/').split('/').length + 5).join('../'));
        var pwd = path.resolve(new Array(parent.replace(/\\+/g, '/').split('/').length + 5).join('../') + m1);
        var str = path.resolve(process.cwd() + '/hui_modules/' + pwd.replace(root, ''));
        console.log(str);
        resultdata = fs.readFile(str, function (err, data) {
            console.log(err);
            if (!err) {
                resultdata = iconv.encode(data, 'UTF8');
                callback('/*path --' + url[0] + '*/\r\n' + resultdata, true);
            }
            else {
                callback('/*Read Error -- ' + url[0] + ' => .' + str.replace(parent, '') + '*/\r\n', false);
            }
        });

    }
};
//合并文件
var mergeFile = function (query, type, callback) {
    var fsArray = query.file.split(',');
    var files = [],
        num = 1;
    var cb = function (text) {
        num--;
        files = files.concat([text]);
        if (num < 1) {
            callback(String(query.debug) !== 'undefined' ? files.join('') :
                (type == 'js' ? minify(files.join('')).code :
                    minicss(files.join(''))));
        }
    };
    var fileMap = {};
    var fileList = [];
    fileMap['hui@0.0.1/hui.js'] = true;
    for (var i = 0, len = fsArray.length; i < len; i++) {
        if (!fileMap[fsArray[i]]) {
            fileMap[fsArray[i]] = true;
            fileList.push(fsArray[i]);
            num++;
        }
    }
    getFile('hui@0.0.1/hui.js', function (text) {
        cb(text);
        for (var i = 0, len = fileList.length; i < len; i++) {
            if (query.host && fileList[i].indexOf('http') !== 0) {
                fileList[i] = query.host + fileList[i];
            }
            getFile(fileList[i], cb);
        }
    });


};
//输出内容
var writeContent = function (req, res, type) {
    req.query = {};
    var url = (String(req.url) + '??').split('??')[1];
    var args = (url + '?').replace(/\s/g, '').split('?');
    req.query.file = args[0] || 'hui@0.0.1/hui.js';

    var list = args[1].split('&');
    var str;
    for (var i = 0, len = list.length; i < len; i++) {
        str = list[i].split('=');
        if (str[0]) {
            req.query[str[0]] = str[1];
        }
    }

    req.query.host = req.host;

    // res.setHeader('Content-Type', 'text/' + (type == 'js' ? 'plain' : 'css'));
    mergeFile(req.query, type, function (code) {
        res.end(code);
    });

};

exports.index = function (req, res) {
    res.end('Js minify And Css minify');
};

exports.js = function (req, res) {
    writeContent(req, res, 'js');
};
exports.css = function (req, res) {
    writeContent(req, res, 'css');
};


//http://localhost:3000/js?file=http://x.libdd.com/farm1/a05baa/fde6509f/jquery.mousewheel-3.0.6.pack.js,http://x.libdd.com/farm1/08871e/95134743/jquery.fancybox-buttons.js
//http://localhost:3000/css?file=http://s.libdd.com/css/base/dd.$7205.css,http://s.libdd.com/css/app/tagpro.$7164.css